<div class="card">
    <div class="card-header">
        <div class="card-header-title font-size-lg font-weight-normal">
            Requerimientos del Huesped <strong>{{ noFolio }}</strong>
        </div>
        <div class="btn-actions-pane-right" *ngIf="showGrid">
            <button class="btn btn-primary btn-lg py-2 px-4" (click)="nuevo()" *ngIf="!consulta || grabarReq">
                <i class="fa fa-plus mr-2"></i>Nuevo
            </button>
        </div>
    </div>

    <div class="card-body">

        <kendo-grid [data]="gridData" [selectable]="true" [reorderable]="true" [resizable]="true" style="height:50vh;"
            *ngIf="showGrid">
            <ng-container *ngIf="gridData.length !== 0">
                <kendo-grid-column field="hnumreq" title="#Req." width="80"></kendo-grid-column>
                <kendo-grid-column field="hdesc" title="Requerimiento" width=""></kendo-grid-column>
                <kendo-grid-column field="hcantidad" title="Cant." width="70"></kendo-grid-column>
                <kendo-grid-column field="hnespecial" title="Nota" width=""></kendo-grid-column>
                <kendo-grid-column field="hentregado" title="E.A." width="70"></kendo-grid-column>
                <kendo-grid-command-column title="Acciones" width="230" *ngIf="!consulta || grabarReq">
                    <ng-template kendoGridCellTemplate let-dataItem>
                        <button class="btn btn-info" [disabled]="loading" (click)="selectRow(dataItem)">
                            <i class="fas mr-2" [ngClass]="{'fa-spinner fa-spin': loading, 'fa-edit': !loading }">
                            </i>Editar
                        </button>
                        <button class="btn btn-danger ml-1" [disabled]="loading" (click)="delete(dataItem)">
                            <i class="fas mr-2" [ngClass]="{'fa-spinner fa-spin': loading, 'fa-trash': !loading }">
                            </i>Eliminar
                        </button>
                    </ng-template>
                </kendo-grid-command-column>
            </ng-container>
            <ng-template kendoGridNoRecordsTemplate>
                No hay resultados para mostrar.
            </ng-template>
        </kendo-grid>

        <div class="container animated fadeIn" *ngIf="!showGrid">
            <form [formGroup]="myFormGroup" class="animated fadeIn">
                <div class="row">
                    <div class="form-group col-sm-6 col-md-4 col-lg-3 col-xl-2" *ngIf="uso !== 'H'">
                        <label>Secuencia</label>
                        <div class="input-group">
                            <input type="text" class="form-control" formControlName="hsecuencia"
                                [readOnly]="dsSecuencias.length <= 1 || method === 'M' || lectura" tabindex="1">
                            <span class="input-group-append">
                                <button (click)="openModal(modalHelp, 'lg')" class="btn btn-info"
                                    [disabled]="dsSecuencias.length <= 1 || method === 'M' || lectura">
                                    <i class="fa fa-search"></i>
                                </button>
                            </span>
                        </div>
                    </div>
                    <div class="form-group col-sm-12 col-md-8 col-lg-6 col-xl-6">
                        <label>Código</label>
                        <kendo-combobox [data]="dsRequerimientos" [textField]="'rdesc'" [valueField]="'rreqesp'"
                            formControlName="hreqesp" [filterable]="true" (filterChange)="handleFilter($event)"
                            (valueChange)="changeCodigo($event)" [readonly]="method === 'M' || lectura" class="w-100"
                            tabindex="2" #focus>
                        </kendo-combobox>
                    </div>
                    <div class="form-group col-sm-4 col-md-4 col-lg-3 col-xl-2">
                        <label>Tipo</label>
                        <kendo-combobox [data]="dataCargos" [textField]="'tcdesc'" [valueField]="'tipoCargo'"
                            [valuePrimitive]="true" formControlName="htcargo" [readonly]="!flagCosto || lectura"
                            class="w-100" tabindex="3">
                        </kendo-combobox>
                    </div>
                    <div class="form-group col-sm-4 col-md-4 col-lg-3 col-xl-2">
                        <label>Cuenta</label>
                        <kendo-combobox [data]="dataCuentas" [textField]="'tcuentadesc'" [valueField]="'tipoCuenta'"
                            formControlName="htfolio" [valuePrimitive]="true" [readonly]="!flagCosto || lectura"
                            class="w-100" tabindex="4">
                        </kendo-combobox>
                    </div>
                    <div class="form-group col-6 col-sm-4 col-md-4 col-lg-3 col-xl-2">
                        <label>Cantidad</label>
                        <input type="number" [readonly]="lectura" class="form-control" formControlName="hcantidad"
                            tabindex="5">
                    </div>
                    <div class="form-group col-6 col-sm-4 col-md-4 col-lg-3 col-xl-2">
                        <label>Monto</label>
                        <input type="number" class="form-control" formControlName="hmonto"
                            [readonly]="!flagCosto || lectura" tabindex="6">
                    </div>
                    <div class="form-group col-sm-6 col-md-8 col-lg-4 col-xl-4">
                        <label>Moneda</label>
                        <kendo-combobox [data]="dataMonedas" [textField]="'mdesc'" [valueField]="'Moneda'"
                            [valuePrimitive]="true" formControlName="hmon"
                            [readonly]="!myFormGroup.value.rcosto || lectura" class="w-100" tabindex="7">
                        </kendo-combobox>
                    </div>
                    <div class="form-group col-12">
                        <label for="notasReq">Notas</label>
                        <textarea class="form-control" rows="2" [readonly]="lectura" formControlName="hnespecial"
                            tabindex="8"></textarea>
                    </div>
                    <div class="col-12 d-flex justify-content-center mt-3">
                        <button class="btn btn-success py-2 px-4" [disabled]="myFormGroup.invalid" (click)="guardar()"
                            *ngIf="!lectura">
                            <i class="fa fa-save mr-2"></i>Guardar
                        </button>
                        <button (click)="regresar()" class="btn btn-secondary py-2 px-4 ml-1">Regresar</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

<ng-template #modalHelp let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h6 class="modal-title"><i class="fas fa-bed mr-2"></i>Secuencias</h6>
        <button class="close" aria-label="Close" (click)="d('Cross click')">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-secuencias [data]="dsSecuencias" (select)="secuenciaSelected($event); c();">
        </app-secuencias>
    </div>
    <div class="modal-footer">
        <button class="btn btn-shadow btn-secondary" (click)="c()">Cerrar</button>
    </div>
</ng-template>

<ng-template #modalDisp let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h6 class="modal-title"><i class="fas fa-wrench mr-2"></i>Disponibilidad de Req. Especiales</h6>
        <button class="close" aria-label="Close" (click)="d('Cross click')">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <table class="table table-responsive">
            <tbody>
                <tr>
                    <td>Req. Esp.</td>
                    <ng-container *ngFor="let item of dsDisp;">
                        <td class="text-right" *ngFor="let item2 of item.DispReqesp;">{{ item2.EtiquetaFecha }}</td>
                    </ng-container>
                </tr>
                <tr>
                    <ng-container *ngFor="let item of dsDisp;">
                        <td class="font-weight-bold">
                            {{ item.ReqEsp }}
                        </td>
                        <td class="text-right" *ngFor="let item2 of item.DispReqesp;">{{ item2.Disponibilidad }}</td>
                    </ng-container>
                </tr>
            </tbody>
        </table>
    </div>
    <div class="modal-footer">
        <button class="btn btn-shadow btn-secondary" (click)="c()">Cerrar</button>
    </div>
</ng-template>